git-filter-branch.shon commit Merge branch 'va/i18n-perl-scripts' (1d73f8e)
   1#!/bin/sh
   2#
   3# Rewrite revision history
   4# Copyright (c) Petr Baudis, 2006
   5# Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
   6#
   7# Lets you rewrite the revision history of the current branch, creating
   8# a new branch. You can specify a number of filters to modify the commits,
   9# files and trees.
  10
  11# The following functions will also be available in the commit filter:
  12
  13functions=$(cat << \EOF
  14warn () {
  15        echo "$*" >&2
  16}
  17
  18map()
  19{
  20        # if it was not rewritten, take the original
  21        if test -r "$workdir/../map/$1"
  22        then
  23                cat "$workdir/../map/$1"
  24        else
  25                echo "$1"
  26        fi
  27}
  28
  29# if you run 'skip_commit "$@"' in a commit filter, it will print
  30# the (mapped) parents, effectively skipping the commit.
  31
  32skip_commit()
  33{
  34        shift;
  35        while [ -n "$1" ];
  36        do
  37                shift;
  38                map "$1";
  39                shift;
  40        done;
  41}
  42
  43# if you run 'git_commit_non_empty_tree "$@"' in a commit filter,
  44# it will skip commits that leave the tree untouched, commit the other.
  45git_commit_non_empty_tree()
  46{
  47        if test $# = 3 && test "$1" = $(git rev-parse "$3^{tree}"); then
  48                map "$3"
  49        else
  50                git commit-tree "$@"
  51        fi
  52}
  53# override die(): this version puts in an extra line break, so that
  54# the progress is still visible
  55
  56die()
  57{
  58        echo >&2
  59        echo "$*" >&2
  60        exit 1
  61}
  62EOF
  63)
  64
  65eval "$functions"
  66
  67finish_ident() {
  68        # Ensure non-empty id name.
  69        echo "case \"\$GIT_$1_NAME\" in \"\") GIT_$1_NAME=\"\${GIT_$1_EMAIL%%@*}\" && export GIT_$1_NAME;; esac"
  70        # And make sure everything is exported.
  71        echo "export GIT_$1_NAME"
  72        echo "export GIT_$1_EMAIL"
  73        echo "export GIT_$1_DATE"
  74}
  75
  76set_ident () {
  77        parse_ident_from_commit author AUTHOR committer COMMITTER
  78        finish_ident AUTHOR
  79        finish_ident COMMITTER
  80}
  81
  82USAGE="[--env-filter <command>] [--tree-filter <command>]
  83        [--index-filter <command>] [--parent-filter <command>]
  84        [--msg-filter <command>] [--commit-filter <command>]
  85        [--tag-name-filter <command>] [--subdirectory-filter <directory>]
  86        [--original <namespace>] [-d <directory>] [-f | --force]
  87        [<rev-list options>...]"
  88
  89OPTIONS_SPEC=
  90. git-sh-setup
  91
  92if [ "$(is_bare_repository)" = false ]; then
  93        require_clean_work_tree 'rewrite branches'
  94fi
  95
  96tempdir=.git-rewrite
  97filter_env=
  98filter_tree=
  99filter_index=
 100filter_parent=
 101filter_msg=cat
 102filter_commit=
 103filter_tag_name=
 104filter_subdir=
 105orig_namespace=refs/original/
 106force=
 107prune_empty=
 108remap_to_ancestor=
 109while :
 110do
 111        case "$1" in
 112        --)
 113                shift
 114                break
 115                ;;
 116        --force|-f)
 117                shift
 118                force=t
 119                continue
 120                ;;
 121        --remap-to-ancestor)
 122                # deprecated ($remap_to_ancestor is set now automatically)
 123                shift
 124                remap_to_ancestor=t
 125                continue
 126                ;;
 127        --prune-empty)
 128                shift
 129                prune_empty=t
 130                continue
 131                ;;
 132        -*)
 133                ;;
 134        *)
 135                break;
 136        esac
 137
 138        # all switches take one argument
 139        ARG="$1"
 140        case "$#" in 1) usage ;; esac
 141        shift
 142        OPTARG="$1"
 143        shift
 144
 145        case "$ARG" in
 146        -d)
 147                tempdir="$OPTARG"
 148                ;;
 149        --env-filter)
 150                filter_env="$OPTARG"
 151                ;;
 152        --tree-filter)
 153                filter_tree="$OPTARG"
 154                ;;
 155        --index-filter)
 156                filter_index="$OPTARG"
 157                ;;
 158        --parent-filter)
 159                filter_parent="$OPTARG"
 160                ;;
 161        --msg-filter)
 162                filter_msg="$OPTARG"
 163                ;;
 164        --commit-filter)
 165                filter_commit="$functions; $OPTARG"
 166                ;;
 167        --tag-name-filter)
 168                filter_tag_name="$OPTARG"
 169                ;;
 170        --subdirectory-filter)
 171                filter_subdir="$OPTARG"
 172                remap_to_ancestor=t
 173                ;;
 174        --original)
 175                orig_namespace=$(expr "$OPTARG/" : '\(.*[^/]\)/*$')/
 176                ;;
 177        *)
 178                usage
 179                ;;
 180        esac
 181done
 182
 183case "$prune_empty,$filter_commit" in
 184,)
 185        filter_commit='git commit-tree "$@"';;
 186t,)
 187        filter_commit="$functions;"' git_commit_non_empty_tree "$@"';;
 188,*)
 189        ;;
 190*)
 191        die "Cannot set --prune-empty and --commit-filter at the same time"
 192esac
 193
 194case "$force" in
 195t)
 196        rm -rf "$tempdir"
 197;;
 198'')
 199        test -d "$tempdir" &&
 200                die "$tempdir already exists, please remove it"
 201esac
 202orig_dir=$(pwd)
 203mkdir -p "$tempdir/t" &&
 204tempdir="$(cd "$tempdir"; pwd)" &&
 205cd "$tempdir/t" &&
 206workdir="$(pwd)" ||
 207die ""
 208
 209# Remove tempdir on exit
 210trap 'cd "$orig_dir"; rm -rf "$tempdir"' 0
 211
 212ORIG_GIT_DIR="$GIT_DIR"
 213ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
 214ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
 215GIT_WORK_TREE=.
 216export GIT_DIR GIT_WORK_TREE
 217
 218# Make sure refs/original is empty
 219git for-each-ref > "$tempdir"/backup-refs || exit
 220while read sha1 type name
 221do
 222        case "$force,$name" in
 223        ,$orig_namespace*)
 224                die "Cannot create a new backup.
 225A previous backup already exists in $orig_namespace
 226Force overwriting the backup with -f"
 227        ;;
 228        t,$orig_namespace*)
 229                git update-ref -d "$name" $sha1
 230        ;;
 231        esac
 232done < "$tempdir"/backup-refs
 233
 234# The refs should be updated if their heads were rewritten
 235git rev-parse --no-flags --revs-only --symbolic-full-name \
 236        --default HEAD "$@" > "$tempdir"/raw-heads || exit
 237sed -e '/^^/d' "$tempdir"/raw-heads >"$tempdir"/heads
 238
 239test -s "$tempdir"/heads ||
 240        die "Which ref do you want to rewrite?"
 241
 242GIT_INDEX_FILE="$(pwd)/../index"
 243export GIT_INDEX_FILE
 244
 245# map old->new commit ids for rewriting parents
 246mkdir ../map || die "Could not create map/ directory"
 247
 248# we need "--" only if there are no path arguments in $@
 249nonrevs=$(git rev-parse --no-revs "$@") || exit
 250if test -z "$nonrevs"
 251then
 252        dashdash=--
 253else
 254        dashdash=
 255        remap_to_ancestor=t
 256fi
 257
 258git rev-parse --revs-only "$@" >../parse
 259
 260case "$filter_subdir" in
 261"")
 262        eval set -- "$(git rev-parse --sq --no-revs "$@")"
 263        ;;
 264*)
 265        eval set -- "$(git rev-parse --sq --no-revs "$@" $dashdash \
 266                "$filter_subdir")"
 267        ;;
 268esac
 269
 270git rev-list --reverse --topo-order --default HEAD \
 271        --parents --simplify-merges --stdin "$@" <../parse >../revs ||
 272        die "Could not get the commits"
 273commits=$(wc -l <../revs | tr -d " ")
 274
 275test $commits -eq 0 && die "Found nothing to rewrite"
 276
 277# Rewrite the commits
 278report_progress ()
 279{
 280        if test -n "$progress" &&
 281                test $git_filter_branch__commit_count -gt $next_sample_at
 282        then
 283                count=$git_filter_branch__commit_count
 284
 285                now=$(date +%s)
 286                elapsed=$(($now - $start_timestamp))
 287                remaining=$(( ($commits - $count) * $elapsed / $count ))
 288                if test $elapsed -gt 0
 289                then
 290                        next_sample_at=$(( ($elapsed + 1) * $count / $elapsed ))
 291                else
 292                        next_sample_at=$(($next_sample_at + 1))
 293                fi
 294                progress=" ($elapsed seconds passed, remaining $remaining predicted)"
 295        fi
 296        printf "\rRewrite $commit ($count/$commits)$progress    "
 297}
 298
 299git_filter_branch__commit_count=0
 300
 301progress= start_timestamp=
 302if date '+%s' 2>/dev/null | grep -q '^[0-9][0-9]*$'
 303then
 304        next_sample_at=0
 305        progress="dummy to ensure this is not empty"
 306        start_timestamp=$(date '+%s')
 307fi
 308
 309if test -n "$filter_index" ||
 310   test -n "$filter_tree" ||
 311   test -n "$filter_subdir"
 312then
 313        need_index=t
 314else
 315        need_index=
 316fi
 317
 318while read commit parents; do
 319        git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
 320
 321        report_progress
 322
 323        case "$filter_subdir" in
 324        "")
 325                if test -n "$need_index"
 326                then
 327                        GIT_ALLOW_NULL_SHA1=1 git read-tree -i -m $commit
 328                fi
 329                ;;
 330        *)
 331                # The commit may not have the subdirectory at all
 332                err=$(GIT_ALLOW_NULL_SHA1=1 \
 333                      git read-tree -i -m $commit:"$filter_subdir" 2>&1) || {
 334                        if ! git rev-parse -q --verify $commit:"$filter_subdir"
 335                        then
 336                                rm -f "$GIT_INDEX_FILE"
 337                        else
 338                                echo >&2 "$err"
 339                                false
 340                        fi
 341                }
 342        esac || die "Could not initialize the index"
 343
 344        GIT_COMMIT=$commit
 345        export GIT_COMMIT
 346        git cat-file commit "$commit" >../commit ||
 347                die "Cannot read commit $commit"
 348
 349        eval "$(set_ident <../commit)" ||
 350                die "setting author/committer failed for commit $commit"
 351        eval "$filter_env" < /dev/null ||
 352                die "env filter failed: $filter_env"
 353
 354        if [ "$filter_tree" ]; then
 355                git checkout-index -f -u -a ||
 356                        die "Could not checkout the index"
 357                # files that $commit removed are now still in the working tree;
 358                # remove them, else they would be added again
 359                git clean -d -q -f -x
 360                eval "$filter_tree" < /dev/null ||
 361                        die "tree filter failed: $filter_tree"
 362
 363                (
 364                        git diff-index -r --name-only --ignore-submodules $commit -- &&
 365                        git ls-files --others
 366                ) > "$tempdir"/tree-state || exit
 367                git update-index --add --replace --remove --stdin \
 368                        < "$tempdir"/tree-state || exit
 369        fi
 370
 371        eval "$filter_index" < /dev/null ||
 372                die "index filter failed: $filter_index"
 373
 374        parentstr=
 375        for parent in $parents; do
 376                for reparent in $(map "$parent"); do
 377                        case "$parentstr " in
 378                        *" -p $reparent "*)
 379                                ;;
 380                        *)
 381                                parentstr="$parentstr -p $reparent"
 382                                ;;
 383                        esac
 384                done
 385        done
 386        if [ "$filter_parent" ]; then
 387                parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
 388                                die "parent filter failed: $filter_parent"
 389        fi
 390
 391        {
 392                while IFS='' read -r header_line && test -n "$header_line"
 393                do
 394                        # skip header lines...
 395                        :;
 396                done
 397                # and output the actual commit message
 398                cat
 399        } <../commit |
 400                eval "$filter_msg" > ../message ||
 401                        die "msg filter failed: $filter_msg"
 402
 403        if test -n "$need_index"
 404        then
 405                tree=$(git write-tree)
 406        else
 407                tree=$(git rev-parse "$commit^{tree}")
 408        fi
 409        workdir=$workdir @SHELL_PATH@ -c "$filter_commit" "git commit-tree" \
 410                "$tree" $parentstr < ../message > ../map/$commit ||
 411                        die "could not write rewritten commit"
 412done <../revs
 413
 414# If we are filtering for paths, as in the case of a subdirectory
 415# filter, it is possible that a specified head is not in the set of
 416# rewritten commits, because it was pruned by the revision walker.
 417# Ancestor remapping fixes this by mapping these heads to the unique
 418# nearest ancestor that survived the pruning.
 419
 420if test "$remap_to_ancestor" = t
 421then
 422        while read ref
 423        do
 424                sha1=$(git rev-parse "$ref"^0)
 425                test -f "$workdir"/../map/$sha1 && continue
 426                ancestor=$(git rev-list --simplify-merges -1 "$ref" "$@")
 427                test "$ancestor" && echo $(map $ancestor) >> "$workdir"/../map/$sha1
 428        done < "$tempdir"/heads
 429fi
 430
 431# Finally update the refs
 432
 433_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 434_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
 435echo
 436while read ref
 437do
 438        # avoid rewriting a ref twice
 439        test -f "$orig_namespace$ref" && continue
 440
 441        sha1=$(git rev-parse "$ref"^0)
 442        rewritten=$(map $sha1)
 443
 444        test $sha1 = "$rewritten" &&
 445                warn "WARNING: Ref '$ref' is unchanged" &&
 446                continue
 447
 448        case "$rewritten" in
 449        '')
 450                echo "Ref '$ref' was deleted"
 451                git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
 452                        die "Could not delete $ref"
 453        ;;
 454        $_x40)
 455                echo "Ref '$ref' was rewritten"
 456                if ! git update-ref -m "filter-branch: rewrite" \
 457                                        "$ref" $rewritten $sha1 2>/dev/null; then
 458                        if test $(git cat-file -t "$ref") = tag; then
 459                                if test -z "$filter_tag_name"; then
 460                                        warn "WARNING: You said to rewrite tagged commits, but not the corresponding tag."
 461                                        warn "WARNING: Perhaps use '--tag-name-filter cat' to rewrite the tag."
 462                                fi
 463                        else
 464                                die "Could not rewrite $ref"
 465                        fi
 466                fi
 467        ;;
 468        *)
 469                # NEEDSWORK: possibly add -Werror, making this an error
 470                warn "WARNING: '$ref' was rewritten into multiple commits:"
 471                warn "$rewritten"
 472                warn "WARNING: Ref '$ref' points to the first one now."
 473                rewritten=$(echo "$rewritten" | head -n 1)
 474                git update-ref -m "filter-branch: rewrite to first" \
 475                                "$ref" $rewritten $sha1 ||
 476                        die "Could not rewrite $ref"
 477        ;;
 478        esac
 479        git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1 ||
 480                 exit
 481done < "$tempdir"/heads
 482
 483# TODO: This should possibly go, with the semantics that all positive given
 484#       refs are updated, and their original heads stored in refs/original/
 485# Filter tags
 486
 487if [ "$filter_tag_name" ]; then
 488        git for-each-ref --format='%(objectname) %(objecttype) %(refname)' refs/tags |
 489        while read sha1 type ref; do
 490                ref="${ref#refs/tags/}"
 491                # XXX: Rewrite tagged trees as well?
 492                if [ "$type" != "commit" -a "$type" != "tag" ]; then
 493                        continue;
 494                fi
 495
 496                if [ "$type" = "tag" ]; then
 497                        # Dereference to a commit
 498                        sha1t="$sha1"
 499                        sha1="$(git rev-parse -q "$sha1"^{commit})" || continue
 500                fi
 501
 502                [ -f "../map/$sha1" ] || continue
 503                new_sha1="$(cat "../map/$sha1")"
 504                GIT_COMMIT="$sha1"
 505                export GIT_COMMIT
 506                new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
 507                        die "tag name filter failed: $filter_tag_name"
 508
 509                echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
 510
 511                if [ "$type" = "tag" ]; then
 512                        new_sha1=$( ( printf 'object %s\ntype commit\ntag %s\n' \
 513                                                "$new_sha1" "$new_ref"
 514                                git cat-file tag "$ref" |
 515                                sed -n \
 516                                    -e '1,/^$/{
 517                                          /^object /d
 518                                          /^type /d
 519                                          /^tag /d
 520                                        }' \
 521                                    -e '/^-----BEGIN PGP SIGNATURE-----/q' \
 522                                    -e 'p' ) |
 523                                git mktag) ||
 524                                die "Could not create new tag object for $ref"
 525                        if git cat-file tag "$ref" | \
 526                           sane_grep '^-----BEGIN PGP SIGNATURE-----' >/dev/null 2>&1
 527                        then
 528                                warn "gpg signature stripped from tag object $sha1t"
 529                        fi
 530                fi
 531
 532                git update-ref "refs/tags/$new_ref" "$new_sha1" ||
 533                        die "Could not write tag $new_ref"
 534        done
 535fi
 536
 537cd "$orig_dir"
 538rm -rf "$tempdir"
 539
 540trap - 0
 541
 542unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
 543test -z "$ORIG_GIT_DIR" || {
 544        GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
 545}
 546test -z "$ORIG_GIT_WORK_TREE" || {
 547        GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
 548        export GIT_WORK_TREE
 549}
 550test -z "$ORIG_GIT_INDEX_FILE" || {
 551        GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
 552        export GIT_INDEX_FILE
 553}
 554
 555if [ "$(is_bare_repository)" = false ]; then
 556        git read-tree -u -m HEAD || exit
 557fi
 558
 559exit 0